SystemOrganization addCategory: #'Arduino-Compiler-Uploading'!
SystemOrganization addCategory: #'Arduino-Compiler-Translator'!
SystemOrganization addCategory: #'Arduino-Compiler-Sketches'!
SystemOrganization addCategory: #'Arduino-Compiler-Nodes'!
SystemOrganization addCategory: #'Arduino-Compiler-Tests'!

!MethodNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 14:59'!
translateInto: aStream with: aTranslator 
aTranslator translateMethodNode: self into: aStream! !

!BlockNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 15:06'!
translateInto: aStream with: aTranslator 
	aTranslator translateBlockNode: self into: aStream! !

!ReturnNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 15:21'!
translateInto: aStream with: aTranslator 
aTranslator translateReturnNode: self into: aStream! !

!SelectorNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 15:20'!
translateInto: aStream with: aTranslator 
aTranslator translateSelectorNode: self into: aStream! !

!VariableNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 15:19'!
translateInto: aStream with: aTranslator 
aTranslator translateVariableNode: self into: aStream! !

Object subclass: #ArduinoCTranslator
	instanceVariableNames: 'sketch stream typeInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Translator'!

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/14/2010 15:58'!
argTypesAt: aByteString 
^((typeInfo at: #methods) detect: [:each| each selector = aByteString]) argTypes! !

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/14/2010 14:45'!
collectInstVarsTypeInfo
^sketch instVarNames with: sketch instVarTypes collect: [:name :type |
	InstVarInfo name: name type: type
	]
! !

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/14/2010 17:51'!
collectMethodsTypeInfo
| returnType argTypes tempTypes args |
^sketch selectors collect: [:sel | 
	returnType := 'void'. 
	argTypes := tempTypes := ''.
	(sketch compiledMethodAt: sel) pragmas do: [:pragma |
		args := pragma arguments first subStrings: {Character space}.
		pragma keyword caseOf: {
			[#returnType:] -> [returnType := args first].
			[#argTypes:] -> [argTypes := args].
			[#tempTypes:] -> [tempTypes := args].
		} otherwise: [].
		].
	MethodInfo selector: sel returnType: returnType argTypes: argTypes tempTypes: tempTypes].
! !

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/14/2010 15:40'!
collectTypeInformation
typeInfo := Dictionary new.
typeInfo at: #instVars put: (self collectInstVarsTypeInfo).
typeInfo at: #methods put: (self collectMethodsTypeInfo).! !

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/19/2010 14:19'!
instVarDeclarationAt: aByteString
| type |
type := ((typeInfo at: #instVars) detect: [:each| each name = aByteString]) type.
^self variableDeclaration: type name: aByteString! !

!ArduinoCTranslator methodsFor: 'testing' stamp: 'Richo 7/19/2010 16:42'!
isCollectionGetter: aMessageNode 
	^ #(#at: ) includes: aMessageNode selector key! !

!ArduinoCTranslator methodsFor: 'testing' stamp: 'Richo 3/2/2010 18:15'!
isConditional: aMessageNode
	^#(#ifTrue: #ifFalse: #ifTrue:ifFalse: #ifFalse:ifTrue: ) includes: aMessageNode selector key! !

!ArduinoCTranslator methodsFor: 'testing' stamp: 'Richo 7/19/2010 16:11'!
isDoLoop: aMessageNode
	^#(#whileTrue: ) includes: aMessageNode selector key! !

!ArduinoCTranslator methodsFor: 'testing' stamp: 'Richo 7/19/2010 18:00'!
isIntegerConstant: aMessageNode 
	^ #(#L ) includes: aMessageNode selector key! !

!ArduinoCTranslator methodsFor: 'testing' stamp: 'Richo 7/19/2010 15:50'!
isIteration: aMessageNode
	^#(#to:do: #to:by:do: ) includes: aMessageNode selector key! !

!ArduinoCTranslator methodsFor: 'testing' stamp: 'Richo 7/19/2010 18:00'!
isVerySpecialMessageNode: aMessageNode 
	"Very special messages are #ifTrue, #to:do:, #whileTrue: and such...
	These messages are so different from the others they require
	special treatment"
	^ (self isConditional: aMessageNode)
		or: [(self isDoLoop: aMessageNode)
				or: [(self isIteration: aMessageNode)
						or: [(self isCollectionGetter: aMessageNode) or: [self isIntegerConstant: aMessageNode]]]]! !

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/14/2010 15:40'!
returnTypeAt: aByteString 
^((typeInfo at: #methods) detect: [:each| each selector = aByteString]) returnType! !

!ArduinoCTranslator methodsFor: 'testing' stamp: 'Richo 7/19/2010 17:58'!
returnsALiteralObject: aMessageNode 
	"Test if the message node returns a literal object such as:
	
	Character space.
	Float pi.
	
	"
	"Character space"
	| receiver |
	receiver := aMessageNode receiver.
	(receiver isKindOf: LiteralVariableNode)
		ifTrue: [receiver name = 'Character'
				ifTrue: [aMessageNode selector key = #space
						ifTrue: [^ true]]].
	^ false! !

!ArduinoCTranslator methodsFor: 'accessing' stamp: 'Richo 3/3/2010 16:58'!
specialSelectorAt: aSymbol 
	^ aSymbol caseOf: {
		[#=] -> [#'=='].
		[#'~='] -> [#'!!='].
		[#'~~'] -> [#'!!='].
		[#pin:mode:] -> [#pinMode].
		[#digitalWrite:value:] -> [#digitalWrite]
	}
		 otherwise: []! !

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/19/2010 14:18'!
tempDeclarationAt: index named: tempName inMethod: methodSelector
| type |
type := ((typeInfo at: #methods) detect: [:each| each selector = methodSelector]) tempTypes at: index.
^self variableDeclaration: type name: tempName! !

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/14/2010 17:08'!
tempTypesAt: aByteString 
^((typeInfo at: #methods) detect: [:each| each selector = aByteString]) tempTypes! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 17:16'!
translateAssignmentNode: anAssignmentNode into: aStream 
	((anAssignmentNode value isKindOf: LeafNode)
			and: [anAssignmentNode value key isCollection])
		ifTrue: [anAssignmentNode value key
				doWithIndex: [:element :index | 
					anAssignmentNode variable translateInto: aStream with: self.
					aStream nextPutAll: '[' , (index - 1) asString , '] = '.
					self translateLiteralObject: element into: aStream.
					aStream nextPut: $;;
						 cr].
			^ self].
	anAssignmentNode variable translateInto: aStream with: self.
	aStream space; nextPut: $=; space.
	anAssignmentNode value translateInto: aStream with: self.
	aStream nextPut: $;! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 16:41'!
translateBlockNode: aBlockNode into: aStream 
	"aStream cr."
	self translateTemporariesOf: aBlockNode into: aStream.
	aBlockNode statements
		do: [:each | 
			each translateInto: aStream with: self.
			(each isMessageNode
					and: [(self isConditional: each) not
							and: [(self isIteration: each) not
									and: [(self isDoLoop: each) not]]])
				ifTrue: [aStream nextPut: $;]] 
		separatedBy: [aStream cr]! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 3/3/2010 17:23'!
translateCascadeNode: aCascadeNode into: aStream 
	| translateReceiver args |
	translateReceiver := [| rcvr |
			rcvr := aCascadeNode receiver.
			rcvr isSelfPseudoVariable
				ifFalse: [rcvr translateInto: aStream with: self.
					aStream nextPut: $.]].
	aCascadeNode messages
		do: [:msg | 
			translateReceiver value.
			msg selector translateInto: aStream with: self.
			aStream nextPut: $(.
			args := msg argumentsInEvaluationOrder.
			args
				do: [:arg | 
					arg translateInto: aStream with: self.
					arg = args last
						ifFalse: [aStream nextPut: $,;
								 space]].
			aStream nextPutAll: ');'; cr]
! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 16:47'!
translateCollectionGetterNode: aMessageNode into: aStream 
	"There is no CollectionGetterNode. This is just a convenience method for
	translating #at: MessageNodes"
	aMessageNode receiver translateInto: aStream with: self.
	aStream nextPutAll: '[('.
	aMessageNode arguments first translateInto: aStream with: self.
	aStream nextPutAll: ') - 1]'.
! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 3/3/2010 15:20'!
translateConditionalNode: aMessageNode into: aStream 
	"There is no ConditionalNode. This is just a convenience method for
	translating #ifTrue:ifFalse: MessageNodes"
	| args |
	args := aMessageNode argumentsInEvaluationOrder.
	aStream nextPutAll: 'if('.
	aMessageNode receiver translateInto: aStream with: self.
	aStream nextPut: $);
		 cr;
		 nextPut: ${.
	args first translateInto: aStream with: self.
	aStream cr; nextPut: $}.
	args second name = '{[]}'
		ifFalse: [aStream cr; nextPutAll: 'else'; cr; nextPut: ${.
			args second translateInto: aStream with: self.
			aStream cr; nextPut: $}]! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 16:20'!
translateDoLoopNode: aMessageNode into: aStream 
	"There is no DoLoopNode. This is just a convenience method for
	translating #whileTrue: MessageNodes"
	aStream nextPutAll: 'while('.
	aMessageNode receiver statements last translateInto: aStream with: self.
	aStream nextPutAll: ') {'; cr.
	aMessageNode arguments first translateInto: aStream with: self.
	aStream cr; nextPut: $}.
	! !

!ArduinoCTranslator methodsFor: 'translating' stamp: 'Richo 7/14/2010 18:09'!
translateInstVarDeclarations
	sketch instVarNames
		do: [:instVarName | stream nextPutAll: (self instVarDeclarationAt: instVarName); cr].
	stream cr! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 18:03'!
translateIntegerConstantNode: aMessageNode into: aStream 
	"There is no IntegerConstantNode. This is just a convenience method for
	translating #L MessageNodes"
	aMessageNode receiver translateInto: aStream with: self.
	aMessageNode selector translateInto: aStream with: self
! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 16:10'!
translateIterationNode: aMessageNode into: aStream 
	"There is no IterationNode. This is just a convenience method for
	translating #to:do: MessageNodes"
	| args |
	args := aMessageNode argumentsInEvaluationOrder.
	aStream nextPutAll: (self variableDeclaration: 'long' name: args first variable name); cr.
	args first translateInto: aStream with: self.
	aStream cr; nextPutAll: 'while('.
	args second translateInto: aStream with: self.
	aStream nextPutAll: ') {'; cr.
	args third translateInto: aStream with: self.
	aStream cr.
	args fourth translateInto: aStream with: self.
	aStream cr.
	aStream nextPut: $}; cr.! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 17:15'!
translateLeafNode: aLiteralNode into: aStream 
	"aLiteralNode key isCollection 
	ifTrue: [
	self halt.
	aStream nextPut: ${.
	aLiteralNode key do: [:each|
	each isCharacter ifTrue: [aStream nextPutAll: each asString
	printString] ifFalse: [each printOn: aStream]] separatedBy: [aStream
	nextPutAll: ', '].
	aStream nextPut: $}
	]
	ifFalse: [aStream nextPutAll: aLiteralNode key asString
	"
	aStream nextPutAll: aLiteralNode key asString! !

!ArduinoCTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 7/19/2010 17:17'!
translateLiteralObject: anObject into: aStream
"This method receives an object as a parameter instead of a ParseNode. It tries to translate the object as a literal value"
anObject isCharacter
	ifTrue: [anObject asciiValue printOn: aStream]
	ifFalse: [anObject printOn: aStream]! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 17:16'!
translateMessageNode: aMessageNode into: aStream 
	| args isBinary |
	(self returnsALiteralObject: aMessageNode)
		ifTrue: [self translateLiteralObject: aMessageNode eval into: aStream.
			^self].
	(self isVerySpecialMessageNode: aMessageNode)
		ifTrue: [self translateVerySpecialMessageNode: aMessageNode into: aStream.
			^ self].
	isBinary := aMessageNode selector key precedence = 2.
	aMessageNode receiver isSelfPseudoVariable
		ifFalse: [aMessageNode receiver translateInto: aStream with: self.
			aStream
				nextPut: (isBinary
						ifTrue: [Character space]
						ifFalse: [$.])].
	aMessageNode selector translateInto: aStream with: self.
	aStream
		nextPut: (isBinary
				ifTrue: [Character space]
				ifFalse: [$(]).
	args := aMessageNode argumentsInEvaluationOrder.
	args
		do: [:arg | 
			arg translateInto: aStream with: self.
			arg = args last
				ifFalse: [aStream nextPut: $,;
						 space]].
	isBinary
		ifFalse: [aStream nextPut: $)]! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/14/2010 18:00'!
translateMethodNode: aMethodNode into: aStream 
	aStream nextPutAll: (self returnTypeAt: aMethodNode selector) , ' '
			, (aMethodNode selector asIdentifier: false) , '('.
	aMethodNode arguments
		withIndexDo: [:arg :index | 
			aStream nextPutAll: ((self argTypesAt: aMethodNode selector) at: index); space.
			arg translateInto: aStream with: self.
			arg = aMethodNode arguments last
				ifFalse: [aStream nextPutAll: ', ']].
	aStream nextPut: $);
		 cr;
		 nextPut: ${;
		 cr.
	self translateTemporariesOf: aMethodNode into: aStream.
	aMethodNode block translateInto: aStream with: self.
	aStream nextPut: $}; cr.! !

!ArduinoCTranslator methodsFor: 'translating' stamp: 'Richo 7/20/2010 15:26'!
translateMethodSource: sourceString 
	^String streamContents: [:aStream | 
		(Parser new parse: sourceString class: UndefinedObject)
			translateInto: aStream
			with: self].
! !

!ArduinoCTranslator methodsFor: 'translating' stamp: 'Richo 7/19/2010 17:30'!
translateMethods
	| parseTrees |
	parseTrees := sketch selectors
		collect: [:selector | 
			(Parser new
				parse: (sketch sourceCodeAt: selector)
				class: sketch)].
	parseTrees do: [:each | self translateOnlyMethodDeclarationOf: each into: stream. stream cr].
	stream cr.
	parseTrees do: [:each| each translateInto: stream with: self. stream cr]
! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 17:55'!
translateOnlyMethodDeclarationOf: aMethodNode into: aStream 
"This exact same code was copy/pasted from #translateMethodNode:into:. Fix this ASAP"
	aStream nextPutAll: (self returnTypeAt: aMethodNode selector)
			, ' '
			, (aMethodNode selector asIdentifier: false) , '('.
	aMethodNode arguments
		withIndexDo: [:arg :index | 
			aStream
				nextPutAll: ((self argTypesAt: aMethodNode selector)
						at: index);
				 space.
			arg translateInto: aStream with: self.
			arg = aMethodNode arguments last
				ifFalse: [aStream nextPutAll: ', ']].
	aStream nextPutAll: ');'! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 3/2/2010 15:22'!
translateReturnNode: aReturnNode into: aWriteStream 
"Do nothing. Por ahora todos los mtodos son void"! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 15:18'!
translateSelectorNode: aSelectorNode into: aStream 
	| s |
	s := self specialSelectorAt: aSelectorNode key.
	s isNil
		ifTrue: [aStream
				nextPutAll: (aSelectorNode key isKeyword
						ifTrue: [aSelectorNode key asIdentifier: false]
						ifFalse: [aSelectorNode key asString])]
		ifFalse: [aStream nextPutAll: s]! !

!ArduinoCTranslator methodsFor: 'translating' stamp: 'Richo 5/11/2010 15:51'!
translateSketch: anArduinoSketchClass 
	| stream |
	stream := WriteStream on: ''.
	self translateSketch: anArduinoSketchClass into: stream.
	^ stream contents! !

!ArduinoCTranslator methodsFor: 'translating' stamp: 'Richo 7/14/2010 14:33'!
translateSketch: anArduinoSketchClass into: aStream
	sketch := anArduinoSketchClass.
	stream := aStream.
	self collectTypeInformation; translateInstVarDeclarations; translateMethods.! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/14/2010 18:22'!
translateTemporariesOf: aMethodNodeOrBlockNode into: aStream 
	aMethodNodeOrBlockNode temporaries isNil ifTrue: [^self].
	aMethodNodeOrBlockNode temporaries
		withIndexDo: [:temp :index | 			
			aStream nextPutAll: (self tempDeclarationAt: index named: temp name inMethod: aMethodNodeOrBlockNode selector); cr].
	aStream cr.! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 3/2/2010 15:20'!
translateVariableNode: aVariableNode into: aStream 
	aStream nextPutAll: aVariableNode name! !

!ArduinoCTranslator methodsFor: 'translating-nodes' stamp: 'Richo 7/19/2010 17:59'!
translateVerySpecialMessageNode: aMessageNode into: aStream 
	"There is no such thing as VerySpecialMessageNode, this is just a
	convenient way to handle special messages that are so different
	from the others they require special treatment."
	(self isConditional: aMessageNode)
		ifTrue: [self translateConditionalNode: aMessageNode into: aStream.
			^ self].
	(self isIteration: aMessageNode)
		ifTrue: [self translateIterationNode: aMessageNode into: aStream.
			^ self].
	(self isDoLoop: aMessageNode)
		ifTrue: [self translateDoLoopNode: aMessageNode into: aStream.
			^ self].
	(self isCollectionGetter: aMessageNode)
		ifTrue: [self translateCollectionGetterNode: aMessageNode into: aStream.
			^ self].
	(self isIntegerConstant: aMessageNode)
		ifTrue: [self translateIntegerConstantNode: aMessageNode into: aStream.
			^ self]! !

!ArduinoCTranslator methodsFor: 'type info' stamp: 'Richo 7/19/2010 14:41'!
variableDeclaration: varType name: varName
"Returns a correct declaration for a variable:

varType = 'int[15]' & varName = 'notes' ----> 'int notes[15];' 
varType = 'long' & varName = 'millis' ----> 'long millis;'

"
| type size |
^('*[*]' match: varType)
	ifTrue: [
		type := (varType copyUpTo: $[).
		size := varType last: (varType size - type size).
		type, ' ', varName, size, ';']
	ifFalse: [varType, ' ', varName, ';']! !

Object subclass: #ArduinoOperatorNode
	instanceVariableNames: 'operator parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoOperatorNode class methodsFor: 'instance creation' stamp: 'Richo 8/4/2010 13:54'!
operator: anArduinoOperatorSymbolNode parameters: parameters
parameters size > 2 ifTrue: [^self error: 'Invalid parameters'].
^(self basicNew setOperator: anArduinoOperatorSymbolNode parameters: parameters asArray) initialize! !

!ArduinoOperatorNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 13:52'!
= anObject 
	^ anObject class == self class
		and: [anObject operator = self operator and: [anObject parameters = self parameters]]! !

!ArduinoOperatorNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 13:53'!
hash
	^ operator hash bitXor: parameters hash! !

!ArduinoOperatorNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 13:52'!
operator
	"Answer the value of operator"

	^ operator! !

!ArduinoOperatorNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 13:52'!
parameters
	"Answer the value of parameters"

	^ parameters! !

!ArduinoOperatorNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 13:53'!
printOn: aStream
parameters first printOn: aStream.
aStream space.
operator printOn: aStream.
aStream space.
parameters second printOn: aStream.! !

!ArduinoOperatorNode methodsFor: 'private' stamp: 'Richo 8/4/2010 13:40'!
setOperator: anArduinoOperatorSymbolNode parameters: anArray 
operator := anArduinoOperatorSymbolNode.
parameters := anArray ! !

Object subclass: #ArduinoOperatorSymbolNode
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoOperatorSymbolNode class methodsFor: 'instance creation' stamp: 'Richo 8/4/2010 13:39'!
key: aByteSymbol
^(self basicNew setKey: aByteSymbol) initialize! !

!ArduinoOperatorSymbolNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 13:50'!
= anObject 
	^ anObject class == self class
		and: [anObject key = self key]! !

!ArduinoOperatorSymbolNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 13:51'!
hash
	^ key hash! !

!ArduinoOperatorSymbolNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 13:51'!
key
^key! !

!ArduinoOperatorSymbolNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 13:51'!
printOn: aStream 
	aStream nextPutAll: key asString! !

!ArduinoOperatorSymbolNode methodsFor: 'private' stamp: 'Richo 8/4/2010 13:39'!
setKey: aByteSymbol 
key := aByteSymbol! !

Object subclass: #ArduinoParseNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

ArduinoParseNode subclass: #ArduinoAssignmentNode
	instanceVariableNames: 'variable value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoAssignmentNode class methodsFor: 'instance creation' stamp: 'Richo 8/3/2010 14:49'!
variable: variableNode value: valueNode
^(self basicNew setVariable: variableNode value: valueNode) initialize! !

!ArduinoAssignmentNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^anObject class == self class and: [anObject variable = variable and: [anObject value = value]]! !

!ArduinoAssignmentNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:03'!
hash
^value hash bitXor: variable hash! !

!ArduinoAssignmentNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:09'!
printOn: aStream
variable printOn: aStream.
aStream space; nextPut: $=; space.
value printOn: aStream! !

!ArduinoAssignmentNode methodsFor: 'private' stamp: 'Richo 8/3/2010 14:50'!
setVariable: variableNode value: valueNode
variable := variableNode.
value := valueNode! !

!ArduinoAssignmentNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:00'!
value
^value! !

!ArduinoAssignmentNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 11:59'!
variable
	"Answer the value of variable"

	^ variable! !

ArduinoParseNode subclass: #ArduinoBlockNode
	instanceVariableNames: 'vars statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoBlockNode class methodsFor: 'instance creation' stamp: 'Richo 8/4/2010 13:27'!
vars: anArray statements: statements 
^(self basicNew setVars: anArray statements: statements asArray) initialize! !

!ArduinoBlockNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject vars = vars
				and: [anObject statements = statements]]! !

!ArduinoBlockNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:03'!
hash
	^ vars hash bitXor: statements hash! !

!ArduinoBlockNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:10'!
printOn: aStream 
aStream nextPutAll: '{ ... }'! !

!ArduinoBlockNode methodsFor: 'private' stamp: 'Richo 8/4/2010 13:28'!
setVars: arrayOrArduinoVariableNodes statements: arrayOfArduinoParseNodes 
vars := arrayOrArduinoVariableNodes.
statements := arrayOfArduinoParseNodes! !

!ArduinoBlockNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 11:59'!
statements
	"Answer the value of statements"

	^ statements! !

!ArduinoBlockNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 11:59'!
vars
	"Answer the value of vars"

	^ vars! !

ArduinoParseNode subclass: #ArduinoConditionalNode
	instanceVariableNames: 'condition trueBranch falseBranch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoConditionalNode class methodsFor: 'instance creation' stamp: 'Richo 8/20/2010 18:12'!
condition: conditionNode trueBranch: trueBlockNode falseBranch: falseBlockNode
^(self basicNew setCondition: conditionNode trueBranch: trueBlockNode falseBranch: falseBlockNode) initialize! !

!ArduinoConditionalNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject condition = condition
				and: [anObject trueBranch = trueBranch and: [anObject falseBranch = falseBranch]]]! !

!ArduinoConditionalNode methodsFor: 'accessing' stamp: 'Richo 8/20/2010 18:19'!
condition
^condition! !

!ArduinoConditionalNode methodsFor: 'accessing' stamp: 'Richo 8/20/2010 18:19'!
falseBranch
^falseBranch ! !

!ArduinoConditionalNode methodsFor: 'comparing' stamp: 'Richo 8/20/2010 18:20'!
hash
	^ condition hash
		bitXor: (trueBranch hash bitXor: falseBranch hash)! !

!ArduinoConditionalNode methodsFor: 'printing' stamp: 'Richo 8/20/2010 18:33'!
printOn: aStream 
	aStream nextPutAll: 'if('.
	condition printOn: aStream.
	aStream nextPutAll: ') '.
	trueBranch printOn: aStream.
	aStream space.
	falseBranch printOn: aStream! !

!ArduinoConditionalNode methodsFor: 'private' stamp: 'Richo 8/20/2010 18:13'!
setCondition: anArduinoParseNode trueBranch: anArduinoBlockNode falseBranch: anArduinoBlockNode2
condition := anArduinoParseNode.
trueBranch := anArduinoBlockNode.
falseBranch := anArduinoBlockNode2! !

!ArduinoConditionalNode methodsFor: 'accessing' stamp: 'Richo 8/20/2010 18:19'!
trueBranch
^trueBranch! !

ArduinoParseNode subclass: #ArduinoFunctionCallNode
	instanceVariableNames: 'name parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoFunctionCallNode class methodsFor: 'instance creation' stamp: 'Richo 8/4/2010 13:28'!
name: functionName parameters: parameters
^(self basicNew setName: functionName parameters: parameters asArray) initialize! !

!ArduinoFunctionCallNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject name = name
				and: [anObject parameters = parameters]]! !

!ArduinoFunctionCallNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:03'!
hash
	^ name hash bitXor: parameters hash! !

!ArduinoFunctionCallNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:00'!
name
^name! !

!ArduinoFunctionCallNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 11:59'!
parameters
	"Answer the value of parameters"

	^ parameters! !

!ArduinoFunctionCallNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:27'!
printOn: aStream 
	name printOn: aStream.
	aStream nextPut: $(.
	parameters
		do: [:each | each printOn: aStream]
		separatedBy: [aStream nextPutAll: ', '].
	aStream nextPut: $)! !

!ArduinoFunctionCallNode methodsFor: 'private' stamp: 'Richo 8/3/2010 15:06'!
setName: anArduinoFunctionNameNode parameters: anOrderedCollection 
name := anArduinoFunctionNameNode.
parameters := anOrderedCollection! !

ArduinoParseNode subclass: #ArduinoFunctionNameNode
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoFunctionNameNode class methodsFor: 'instance creation' stamp: 'Richo 8/3/2010 14:58'!
key: aByteSymbol 
^(self basicNew setKey: aByteSymbol) initialize! !

!ArduinoFunctionNameNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject key = key]! !

!ArduinoFunctionNameNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:04'!
hash
	^ key hash! !

!ArduinoFunctionNameNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 11:59'!
key
	"Answer the value of key"

	^ key! !

!ArduinoFunctionNameNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:24'!
printOn: aStream 
	aStream nextPutAll: key asString! !

!ArduinoFunctionNameNode methodsFor: 'private' stamp: 'Richo 8/3/2010 14:59'!
setKey: aByteSymbol 
key := aByteSymbol ! !

ArduinoParseNode subclass: #ArduinoFunctionNode
	instanceVariableNames: 'name parameters body temporaries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoFunctionNode class methodsFor: 'as yet unclassified' stamp: 'Richo 8/4/2010 13:27'!
name: functionName parameters: functionParameters temporaries: functionTempVars body: functionBody
^(self basicNew setName: functionName parameters: functionParameters asArray temporaries: functionTempVars asArray body: functionBody) initialize! !

!ArduinoFunctionNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 13:21'!
= anObject 
	^ anObject class == self class
		and: [anObject name = self name and: [anObject parameters = self parameters
				and: [anObject temporaries = self temporaries and: [anObject body = self body]]]]! !

!ArduinoFunctionNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 11:59'!
body
	"Answer the value of body"

	^ body! !

!ArduinoFunctionNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 13:21'!
hash
	^ (name hash bitXor: parameters hash) bitXor: (body hash bitXor: temporaries hash)! !

!ArduinoFunctionNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:01'!
name
^name! !

!ArduinoFunctionNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 11:59'!
parameters
	"Answer the value of parameters"

	^ parameters! !

!ArduinoFunctionNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:22'!
printOn: aStream 
	name printOn: aStream.
	aStream nextPut: $(.
	parameters
		do: [:each | each printOn: aStream]
		separatedBy: [aStream nextPutAll: ', '].
	aStream nextPut: $)! !

!ArduinoFunctionNode methodsFor: 'private' stamp: 'Richo 8/4/2010 13:24'!
setName: anArduinoFunctionNameNode parameters: anArrayOfArduinoVariableNodes1 temporaries: anArrayOfArduinoVariableNodes2 body: anArduinoBlockNode 
name := anArduinoFunctionNameNode.
parameters := anArrayOfArduinoVariableNodes1.
temporaries := anArrayOfArduinoVariableNodes2.
body := anArduinoBlockNode.! !

!ArduinoFunctionNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 13:21'!
temporaries
^temporaries ! !

ArduinoParseNode subclass: #ArduinoLiteralNode
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoLiteralNode class methodsFor: 'instance creation' stamp: 'Richo 8/3/2010 13:10'!
key: aLiteralObject
^(self basicNew setKey: aLiteralObject) initialize! !

!ArduinoLiteralNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject key = key]! !

!ArduinoLiteralNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:04'!
hash
	^ key hash ! !

!ArduinoLiteralNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 11:59'!
key
	"Answer the value of key"

	^ key! !

!ArduinoLiteralNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:23'!
printOn: aStream 
	aStream nextPutAll: key asString! !

!ArduinoLiteralNode methodsFor: 'private' stamp: 'Richo 8/3/2010 13:10'!
setKey: aLiteralObject
key := aLiteralObject! !

ArduinoParseNode subclass: #ArduinoLiteralVariableNode
	instanceVariableNames: 'name value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoLiteralVariableNode class methodsFor: 'instance creation' stamp: 'Richo 8/3/2010 15:04'!
name: aByteSymbol value: anObject
^(self basicNew setName: aByteSymbol value: anObject) initialize
! !

!ArduinoLiteralVariableNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject name = name and: [anObject value = value]]! !

!ArduinoLiteralVariableNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:04'!
hash
	^ value hash bitXor: name hash! !

!ArduinoLiteralVariableNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:01'!
name
^name! !

!ArduinoLiteralVariableNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:24'!
printOn: aStream 
	aStream nextPutAll: name asString;
		 space;
		 nextPutAll: '->';
		 space.
	value printOn: aStream! !

!ArduinoLiteralVariableNode methodsFor: 'private' stamp: 'Richo 8/3/2010 15:04'!
setName: aByteSymbol value: anObject
name := aByteSymbol.
value := anObject! !

!ArduinoLiteralVariableNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:01'!
value
	^ value! !

ArduinoParseNode subclass: #ArduinoLoopNode
	instanceVariableNames: 'initializer test body counting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoLoopNode class methodsFor: 'instance creation' stamp: 'Richo 8/23/2010 17:00'!
initializer: initializerNode test: testNode body: bodyNode counting: countingNode
^(self basicNew setInitializer: initializerNode test: testNode body: bodyNode counting: countingNode) initialize! !

!ArduinoLoopNode class methodsFor: 'instance creation' stamp: 'Richo 8/23/2010 17:47'!
test: testNode body: bodyNode
^self initializer: ArduinoNoOpNode new test: testNode body: bodyNode counting: ArduinoNoOpNode new! !

!ArduinoLoopNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:10'!
= anObject
^anObject class = self class and: [anObject initializer = initializer and: [anObject test = test and: [anObject body = body and: [anObject counting = counting]]]]! !

!ArduinoLoopNode methodsFor: 'accessing' stamp: 'Richo 8/23/2010 17:10'!
body
^body! !

!ArduinoLoopNode methodsFor: 'accessing' stamp: 'Richo 8/23/2010 17:10'!
counting
^counting! !

!ArduinoLoopNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:08'!
hash
	^(initializer hash bitXor: test hash)
		bitXor: (body hash bitXor: counting hash)! !

!ArduinoLoopNode methodsFor: 'accessing' stamp: 'Richo 8/23/2010 17:10'!
initializer
^initializer ! !

!ArduinoLoopNode methodsFor: 'private' stamp: 'Richo 8/23/2010 17:00'!
setInitializer: initializerNode test: testNode body: bodyNode counting: countingNode
	initializer := initializerNode.
	test := testNode.
	body := bodyNode.
	counting := countingNode! !

!ArduinoLoopNode methodsFor: 'accessing' stamp: 'Richo 8/23/2010 17:10'!
test
^test! !

ArduinoParseNode subclass: #ArduinoNoOpNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoNoOpNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:48'!
= anObject
^anObject class = self class! !

!ArduinoNoOpNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:48'!
hash
^self class hash! !

!ArduinoParseNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:05'!
= anObject 
	^ self subclassResponsibility! !

!ArduinoParseNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:06'!
hash
	^ self subclassResponsibility! !

ArduinoParseNode subclass: #ArduinoProgramNode
	instanceVariableNames: 'vars functions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoProgramNode class methodsFor: 'instance creation' stamp: 'Richo 8/4/2010 13:28'!
vars: instanceVariables functions: functions 
	^ (self basicNew setVars: instanceVariables functions: functions asArray) initialize! !

!ArduinoProgramNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject vars = vars
				and: [anObject functions = functions]]! !

!ArduinoProgramNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:00'!
functions
	"Answer the value of functions"

	^ functions! !

!ArduinoProgramNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:05'!
hash
	^ vars hash bitXor: functions hash! !

!ArduinoProgramNode methodsFor: 'private' stamp: 'Richo 8/3/2010 12:47'!
setVars: anArray functions: anArray2 
	vars := anArray.
	functions := anArray2! !

!ArduinoProgramNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:00'!
vars
	"Answer the value of vars"

	^ vars! !

ArduinoParseNode subclass: #ArduinoReturnNode
	instanceVariableNames: 'expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoReturnNode class methodsFor: 'instance creation' stamp: 'Richo 8/3/2010 15:10'!
expression: anArduinoParseNode
^(self basicNew setExpression: anArduinoParseNode) initialize! !

!ArduinoReturnNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject expression = expression]! !

!ArduinoReturnNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:00'!
expression
	"Answer the value of expression"

	^ expression! !

!ArduinoReturnNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:05'!
hash
	^ expression hash ! !

!ArduinoReturnNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:27'!
printOn: aStream 
	aStream nextPutAll: 'return '.
	expression printOn: aStream! !

!ArduinoReturnNode methodsFor: 'private' stamp: 'Richo 8/3/2010 15:10'!
setExpression: anArduinoParseNode 
expression := anArduinoParseNode ! !

ArduinoParseNode subclass: #ArduinoVariableNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Nodes'!

!ArduinoVariableNode class methodsFor: 'instance creation' stamp: 'Richo 8/3/2010 12:45'!
name: aByteString 
	^(self basicNew setName: aByteString) initialize! !

!ArduinoVariableNode methodsFor: 'comparing' stamp: 'Richo 8/23/2010 17:09'!
= anObject 
	^ anObject class == self class
		and: [anObject name = name]! !

!ArduinoVariableNode methodsFor: 'comparing' stamp: 'Richo 8/4/2010 12:05'!
hash
	^ name hash! !

!ArduinoVariableNode methodsFor: 'accessing' stamp: 'Richo 8/4/2010 12:01'!
name
^name! !

!ArduinoVariableNode methodsFor: 'printing' stamp: 'Richo 8/4/2010 12:24'!
printOn: aStream 
	aStream nextPutAll: name asString! !

!ArduinoVariableNode methodsFor: 'private' stamp: 'Richo 8/3/2010 12:46'!
setName: aByteString 
	name := aByteString! !

Object subclass: #ArduinoPreTranslator
	instanceVariableNames: 'returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Translator'!

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:25'!
createConditionalNodeFrom: aMessageNode 
| condition trueBranch falseBranch |
aMessageNode receiver accept: self.
condition := returnValue.
aMessageNode arguments first accept: self.
trueBranch := returnValue.
aMessageNode arguments second accept: self.
falseBranch := returnValue.
^ArduinoConditionalNode condition: condition trueBranch: trueBranch falseBranch: falseBranch! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:24'!
createFunctionCallNodeFrom: aMessageNode 
	"If the receiver is not self it adds the receiver as the first parameter
	of the function, if it is self it just ignores it."
	| name parameters |
	aMessageNode selector accept: self.
	name := returnValue.
	parameters := self
				flatten: (aMessageNode arguments
						collect: [:each | 
							each accept: self.
							returnValue]).
	aMessageNode receiver isSelfPseudoVariable
		ifFalse: [aMessageNode receiver accept: self.
			parameters := (Array with: returnValue)
						, parameters].
	^ ArduinoFunctionCallNode name: name parameters: parameters! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:23'!
createLoopNodeFromToDo: aMessageNode 
	| args initializer test body counting |
	args := aMessageNode argumentsInEvaluationOrder.
	args first accept: self.
	initializer := returnValue.
	args second accept: self.
	test := returnValue.
	args third accept: self.
	body := returnValue.
	args fourth accept: self.
	counting := returnValue.
	^ ArduinoLoopNode
		initializer: initializer
		test: test
		body: body
		counting: counting! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:25'!
createLoopNodeFromWhile: aMessageNode 
	| test body |
	aMessageNode receiver accept: self.
	test := returnValue.
	aMessageNode selector key = #whileFalse:
		ifTrue: [
			"If the selector is #whileFalse: I negate the last statement of
			the test node, so that it will always work as a while()"
			test := ArduinoBlockNode vars: test vars statements: test statements allButLast , 							{ArduinoFunctionCallNode
								name: (ArduinoFunctionNameNode key: 'not')
								parameters: {test statements last}}].
	aMessageNode arguments first accept: self.
	body := returnValue.
	^ ArduinoLoopNode test: test body: body! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:23'!
createOperatorNodeFrom: aMessageNode 
| operator receiver parameters |
aMessageNode selector accept: self.
operator := returnValue.
aMessageNode receiver accept: self.
receiver := returnValue.
parameters := aMessageNode arguments collect: [:each | each accept: self. returnValue].
^ArduinoOperatorNode operator: operator parameters: {receiver} , parameters! !

!ArduinoPreTranslator methodsFor: 'utilities' stamp: 'Richo 8/3/2010 17:40'!
flatten: aCollection
| newCollection |
newCollection := OrderedCollection new.
aCollection do: [:element |
	(element isCollection and: [element isString not])
		ifTrue: [newCollection addAll: (self flatten: element)]
		ifFalse: [newCollection add: element]
	].
^newCollection asArray
! !

!ArduinoPreTranslator methodsFor: 'translating' stamp: 'Richo 8/20/2010 16:32'!
translateExpression: aString
^(self translateMethod: 'emptyMethod ', aString) body statements first! !

!ArduinoPreTranslator methodsFor: 'translating' stamp: 'Richo 8/23/2010 18:25'!
translateMethod: aString 
	(Parser new parse: aString class: Object)
		accept: self.
	^ returnValue! !

!ArduinoPreTranslator methodsFor: 'translating' stamp: 'Richo 8/23/2010 18:23'!
translateSketch: sketch 
| vars functions |
vars := (sketch instVarNames
				collect: [:each | ArduinoVariableNode name: each]).
functions := sketch selectors collect: [:selector | (Parser new
						parse: (sketch sourceCodeAt: selector)
						class: sketch)
						accept: self. returnValue].
^ ArduinoProgramNode vars: vars functions: functions! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:23'!
visitAssignmentNode: anAssignmentNode 
| variable value |
anAssignmentNode variable accept: self.
variable := returnValue.
anAssignmentNode value accept: self.
value := returnValue.
returnValue := (ArduinoAssignmentNode variable: variable value: value).! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:25'!
visitBlockNode: aBlockNode 
	| vars statements |
	vars := aBlockNode temporaries isNil
				ifTrue: [#()]
				ifFalse: [aBlockNode temporaries
						collect: [:each | 
							each accept: self.
							returnValue]].
	statements := self flatten: (aBlockNode statements
				collect: [:each | 
					each accept: self.
					returnValue]).
	returnValue
		:= (ArduinoBlockNode vars: vars statements: statements)! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:23'!
visitCascadeNode: aCascadeNode 
	"Returns a collection of message nodes with the same receiver"
	returnValue
		:= (self
				flatten: (aCascadeNode messages
						collect: [:each | 
							each receiver: aCascadeNode receiver;
								 accept: self.
							returnValue]))! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:25'!
visitInstanceVariableNode: anInstanceVariableNode 
	returnValue := (ArduinoVariableNode name: anInstanceVariableNode name)! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:25'!
visitLiteralNode: aLiteralNode 
	returnValue := (ArduinoLiteralNode key: aLiteralNode key)! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:24'!
visitLiteralVariableNode: aLiteralVariableNode 
returnValue := (ArduinoLiteralVariableNode name: aLiteralVariableNode key key value: aLiteralVariableNode key value)! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:41'!
visitMessageNode: aMessageNode 
	"First we check for special messages"
	(#(#whileTrue: #whileFalse:) includes: aMessageNode selector key)
		ifTrue: [returnValue := (self createLoopNodeFromWhile: aMessageNode). ^self].
	(#(#to:by:do:) includes: aMessageNode selector key)
		ifTrue: [returnValue := (self createLoopNodeFromToDo: aMessageNode). ^self].
	(#(#ifTrue: #ifFalse: #ifTrue:ifFalse:) includes: aMessageNode selector key)
		ifTrue: [returnValue := (self createConditionalNodeFrom: aMessageNode). ^self].
	"If we get here, the message is normal. It can either be an operator or a regular function call"
	aMessageNode selector key precedence = 2
		ifTrue: [returnValue
				:= (self createOperatorNodeFrom: aMessageNode)]
		ifFalse: [returnValue
				:= (self createFunctionCallNodeFrom: aMessageNode)]! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:24'!
visitMethodNode: aMethodNode 
	| parameters body temporaries |
	parameters := aMethodNode arguments
				collect: [:each | 
					each accept: self.
					returnValue].
	temporaries := aMethodNode temporaries collect: [:each | each accept: self. returnValue].
	aMethodNode block accept: self.
	body := returnValue.
	returnValue := (ArduinoFunctionNode
				name: (ArduinoFunctionNameNode key: aMethodNode selector)
				parameters: parameters
				temporaries: temporaries
				body: body)! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:25'!
visitReturnNode: aReturnNode 
aReturnNode expr accept: self.
returnValue := (ArduinoReturnNode expression: returnValue)! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:42'!
visitSelectorNode: aSelectorNode 
aSelectorNode key precedence = 2
	ifTrue: [returnValue := (ArduinoOperatorSymbolNode key: aSelectorNode key)]
	ifFalse: [returnValue := (ArduinoFunctionNameNode key: aSelectorNode key)]! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:24'!
visitTempVariableNode: aTempVariableNode 
returnValue := (ArduinoVariableNode name: aTempVariableNode name)! !

!ArduinoPreTranslator methodsFor: 'visiting' stamp: 'Richo 8/23/2010 18:24'!
visitVariableNode: aVariableNode 
returnValue := (ArduinoVariableNode name: aVariableNode key)! !

Object subclass: #ArduinoSketch
	instanceVariableNames: ''
	classVariableNames: 'HIGH INPUT LOW OUTPUT'
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

ArduinoSketch class
	instanceVariableNames: 'instVarTypes'!

ArduinoSketch class
	instanceVariableNames: 'instVarTypes'!

ArduinoSketch subclass: #ArduinoBlinkSketch
	instanceVariableNames: 'ledPin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoBlinkSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
loop
	self digitalWrite: ledPin value: HIGH;
		 delay: 100;
		 digitalWrite: ledPin value: LOW;
		 delay: 1000! !

!ArduinoBlinkSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
setup
	ledPin := 12.
	self pin: ledPin mode: OUTPUT! !

ArduinoSketch subclass: #ArduinoBlinkWithoutDelaySketch
	instanceVariableNames: 'ledPin ledState previousMillis interval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoBlinkWithoutDelaySketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
loop
	self millis - previousMillis > interval
	ifTrue: [
		previousMillis := self millis.
		ledState = LOW
		ifTrue: [
			ledState := HIGH
			]
		ifFalse: [
			ledState := LOW
			]
		].
	
	self digitalWrite: ledPin value: ledState! !

!ArduinoBlinkWithoutDelaySketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
setup
	ledPin := 13.
	ledState := LOW.
	previousMillis := 0.
	interval := 100.
	self  pin: ledPin mode: OUTPUT! !

ArduinoSketch subclass: #ArduinoButtonSketch
	instanceVariableNames: 'buttonPin ledPin buttonState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoButtonSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
loop
buttonState := self digitalRead: buttonPin.
buttonState = HIGH
ifTrue: [
	self digitalWrite: ledPin value: HIGH
	]
ifFalse: [
	self digitalWrite: ledPin value: LOW
	]! !

!ArduinoButtonSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
setup
ledPin := 12.
buttonPin := 9.
buttonState := 0.
self pin: ledPin mode: OUTPUT; pin: buttonPin mode: INPUT! !

ArduinoSketch subclass: #ArduinoDebounceSketch
	instanceVariableNames: 'buttonPin ledPin ledState buttonState lastButtonState lastDebounceTime debounceDelay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoDebounceSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
loop
<tempTypes: 'int'>
| reading |
reading := self digitalRead: buttonPin.
reading ~= lastButtonState ifTrue: [lastDebounceTime := self millis].
(self millis - lastDebounceTime)  > debounceDelay ifTrue: [buttonState := reading].
self digitalWrite: ledPin value: buttonState.
lastButtonState := reading! !

!ArduinoDebounceSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:16'!
setup
buttonPin := 9.
ledPin := 12.
ledState := HIGH.
lastButtonState := LOW.
lastDebounceTime := 0.
debounceDelay := 50.
self pin: buttonPin mode: INPUT; pin: ledPin mode: OUTPUT! !

ArduinoSketch subclass: #ArduinoEmptySketch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

ArduinoSketch subclass: #ArduinoMelodySketch
	instanceVariableNames: 'speakerPin length notes beats tempo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoMelodySketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:36'!
loop
1 to: length do: [:i|
	(notes at: i) = Character space 
	ifTrue: [
		self delay: (beats at: i) * tempo.
	]
	ifFalse: [
		self playNote: (notes at: i) duration: (beats at: i) * tempo.
	].
	self delay: tempo / 2
]! !

!ArduinoMelodySketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/19/2010 16:01'!
playNote: note duration: duration
<argTypes: 'char int'> <tempTypes: 'char[8] int[8]'>
| names tones |
names := #( $c $d $e $f $g $a $b $C).
tones := #(1915 1700 1519 1432 1275 1136 1014 956 ).

1 to: 8 do: [:i |
		(names at: i) = note ifTrue: [
			self playTone: (tones at: i) duration: duration
			]
		]! !

!ArduinoMelodySketch methodsFor: 'as yet unclassified' stamp: 'Richo 8/23/2010 18:48'!
playTone: tone duration: duration
<argTypes: 'int int'> <tempTypes: 'long'>
| i |
i := 0.
[i < duration * 1000 long]
	whileTrue: [
		self digitalWrite: speakerPin value: HIGH;
			delayMicroseconds: tone;
			digitalWrite: speakerPin value: LOW;
			delayMicroseconds: tone.
		i := i + (tone * 2).
		]! !

!ArduinoMelodySketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/19/2010 17:51'!
setup
speakerPin := 11.
length := 15.
notes := 'ccggaagffeeddc '.
beats := #(1 1 1 1 1 1 2 1 1 1 1 1 1 2 4).
tempo := 300.	
self pin: speakerPin mode: OUTPUT! !

!ArduinoSketch class methodsFor: 'as yet unclassified' stamp: 'Richo 8/3/2010 12:44'!
definition
	"Answer a String that defines the receiver."
	| aStream path |
	self = ArduinoSketch ifTrue: [^super definition].
	aStream := WriteStream
				on: (String new: 300).
	superclass == nil
		ifTrue: [aStream nextPutAll: 'ProtoObject']
		ifFalse: [path := ''.
			self environment
				scopeFor: superclass name
				from: nil
				envtAndPathIfFound: [:envt :remotePath | path := remotePath].
			aStream nextPutAll: path , superclass name].
	aStream nextPutAll: self kindOfSubclass;
		 store: self name.
	(self hasTraitComposition
			and: [self traitComposition notEmpty])
		ifTrue: [aStream cr; tab; nextPutAll: 'uses: '; nextPutAll: self traitCompositionString].
	aStream cr; tab; nextPutAll: 'instanceVariableNames: '; store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'instanceVariableTypes: '; store: self instanceVariableTypesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: '; store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: '; store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: '; store: (SystemOrganization categoryOfElement: self name) asString.
	superclass
		ifNil: [aStream nextPutAll: '.';
				 cr.
			aStream nextPutAll: self name.
			aStream space; nextPutAll: 'superclass: nil'].
	^ aStream contents! !

!ArduinoSketch class methodsFor: 'class initialization' stamp: 'Richo 3/3/2010 16:38'!
initialize
	"ArduinoSketch initialize"
	HIGH := OUTPUT := 1.
	LOW := INPUT := 0! !

!ArduinoSketch class methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 13:37'!
instVarTypes 
	"Answer an Array of the receiver's instance variable names."

	instVarTypes == nil
		ifTrue: [^#()]
		ifFalse: [^instVarTypes]! !

!ArduinoSketch class methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:01'!
instanceVariableTypes: aString 
instVarTypes := aString withBlanksTrimmed subStrings: {Character space}.
(self instVarNames size = instVarTypes size) 
	ifFalse: [instVarTypes := nil. ^self error: 'Diferente cantidad de variables de intancia y tipos'].
instVarTypes isEmpty ifTrue: [instVarTypes := nil]
! !

!ArduinoSketch class methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 13:37'!
instanceVariableTypesString
	"Answer a string of my instance variable names separated by spaces."

	^String streamContents: [ :stream |
		self instVarTypes 
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream space ] ]! !

!ArduinoSketch class methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 13:24'!
subclass: nameOfClass instanceVariableNames: instVarNames instanceVariableTypes: instVarTypes classVariableNames: classVarNames poolDictionaries: poolDictnames category: category 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver)."
	^(ClassBuilder new
		superclass: self
		subclass: nameOfClass
		instanceVariableNames: instVarNames
		classVariableNames: classVarNames
		poolDictionaries: poolDictnames
		category: category) instanceVariableTypes: instVarTypes.
		! !

!ArduinoSketch methodsFor: 'functions-time' stamp: 'Richo 3/3/2010 17:54'!
delay: milliseconds 
	"Pauses the program for the amount of time (in miliseconds) specified
	as parameter. (There are 1000 milliseconds in a second.)
	
	Caveat

While it is easy to create a blinking LED with the delay() function, and many sketches use short delays for such tasks as switch debouncing, the use of delay() in a sketch has significant drawbacks. No other reading of sensors, mathematical calculations, or pin manipulation can go on during the delay function, so in effect, it brings most other activity to a halt. For alternative approaches to controlling timing see the millis() function and the sketch sited below. More knowledgeable programmers usually avoid the use of delay() for timing of events longer than 10's of milliseconds unless the Arduino sketch is very simple.

Certain things do go on while the delay() function is controlling the Atmega chip however, because the delay function does not disable interrupts. Serial communication that appears at the RX pin is recorded, PWM (analogWrite) values and pin states are maintained, and interrupts will work as they should."
	^ self! !

!ArduinoSketch methodsFor: 'functions-time' stamp: 'Richo 7/14/2010 17:29'!
delayMicroseconds: microseconds
"Pauses the program for the amount of time (in microseconds) specified as parameter. There are a thousand microseconds in a millisecond, and a million microseconds in a second.

Currently, the largest value that will produce an accurate delay is 16383. This could change in future Arduino releases. For delays longer than a few thousand microseconds, you should use delay() instead.

Caveats and Known Issues

This function works very accurately in the range 3 microseconds and up. We cannot assure that delayMicroseconds will perform precisely for smaller delay-times."
^self! !

!ArduinoSketch methodsFor: 'functions-digital i/o' stamp: 'Richo 7/14/2010 16:41'!
digitalRead: pin
"Reads the value from a specified digital pin, either HIGH or LOW."
^self! !

!ArduinoSketch methodsFor: 'functions-digital i/o' stamp: 'Richo 3/3/2010 17:55'!
digitalWrite: pinNumber value: pinValue 
	"Write a HIGH or a LOW value to a digital pin.
	
	If the pin has been configured as an OUTPUT with pinMode(), its
	voltage will be set to the corresponding value: 5V (or 3.3V on 3.3V
	boards) for HIGH, 0V (ground) for LOW.
	
	If the pin is configured as an INPUT, writing a HIGH value with
	digitalWrite() will enable an internal 20K pullup resistor (see the
	tutorial on digital pins). Writing LOW will disable the pullup. The pullup
	resistor is enough to light an LED dimly, so if LEDs appear to work,
	but very dimly, this is a likely cause. The remedy is to set the pin to
	an output with the pinMode() function.
	
	Note

The analog input pins can also be used as digital pins, referred to as numbers 14 (analog input 0) to 19 (analog input 5).
	"
	^ self! !

!ArduinoSketch methodsFor: 'structure' stamp: 'Richo 3/3/2010 17:38'!
loop
"After creating a setup() function, which initializes and sets the initial values, the loop() function does precisely what its name suggests, and loops consecutively, allowing your program to change and respond. Use it to actively control the Arduino board."
	self subclassResponsibility! !

!ArduinoSketch methodsFor: 'functions-time' stamp: 'Richo 3/3/2010 17:56'!
millis
	"Returns the number of milliseconds since the Arduino board began
	running the current program. This number will overflow (go back to
	zero), after approximately 50 days.
	
	Tip:
	
	Note that the parameter for millis is an unsigned long, errors may be
	generated if a programmer tries to do math with other datatypes
	such as ints.
	"
	^ self! !

!ArduinoSketch methodsFor: 'functions-digital i/o' stamp: 'Richo 3/3/2010 17:55'!
pin: pinNumber mode: pinMode 
	"Configures the specified pin to behave either as an input or an
	output. See the description of digital pins for details.

	Note

The analog input pins can be used as digital pins, referred to as numbers 14 (analog input 0) to 19 (analog input 5).
	"
	^ self! !

!ArduinoSketch methodsFor: 'structure' stamp: 'Richo 3/3/2010 17:38'!
setup
"The setup() function is called when a sketch starts. Use it to initialize variables, pin modes, start using libraries, etc. The setup function will only run once, after each powerup or reset of the Arduino board."
	self subclassResponsibility! !

ArduinoSketch subclass: #ArduinoTestSketch
	instanceVariableNames: 'led servo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Sketches'!

!ArduinoTestSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
loop
self turnOnLed: 15! !

!ArduinoTestSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2010 17:17'!
setup
led := 13.
servo := 9! !

!ArduinoTestSketch methodsFor: 'as yet unclassified' stamp: 'Richo 7/19/2010 17:04'!
turnOnLed: aNumber
Character space! !

Object subclass: #ArduinoSketchCompiler
	instanceVariableNames: 'sketch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

!ArduinoSketchCompiler class methodsFor: 'accessing' stamp: 'Richo 5/14/2010 18:41'!
makefile
^'# Arduino 0015 Makefile
# Arduino adaptation by mellis, eighthave, oli.keller
#
# This makefile allows you to build sketches from the command line
# without the Arduino environment (or Java).
#
# Detailed instructions for using the makefile:
#
#  1. Copy this file into the folder with your sketch. There should be a
#     file with the same name as the folder and with the extension .pde
#     (e.g. foo.pde in the foo/ folder).
#
#  2. Modify the line containg "INSTALL_DIR" to point to the directory that
#     contains the Arduino installation (for example, under Mac OS X, this
#     might be /Applications/arduino-0012).
#
#  3. Modify the line containing "PORT" to refer to the filename
#     representing the USB or serial connection to your Arduino board
#     (e.g. PORT = /dev/tty.USB0).  If the exact name of this file
#     changes, you can use * as a wildcard (e.g. PORT = /dev/tty.usb*).
#
#  4. Set the line containing "MCU" to match your board''s processor. 
#     Older one''s are atmega8 based, newer ones like Arduino Mini, Bluetooth
#     or Diecimila have the atmega168.  If you''re using a LilyPad Arduino,
#     change F_CPU to 8000000.
#
#  5. At the command line, change to the directory containing your
#     program''file and the makefile.
#
#  6. Type "make" and press enter to compile/verify your program.
#
#  7. Type "make upload", reset your Arduino board, and press enter to
#     upload your program to the Arduino board.
#
# $Id$

TARGET = Blink
INSTALL_DIR = ../..
PORT = com6
UPLOAD_RATE = 57600
AVRDUDE_PROGRAMMER = stk500
MCU = atmega328p
F_CPU = 16000000

############################################################################
# Below here nothing should be changed...

ARDUINO = $(INSTALL_DIR)/hardware/cores/arduino
AVR_TOOLS_PATH = $(INSTALL_DIR)/hardware/tools/avr/bin
SRC =  $(ARDUINO)/pins_arduino.c $(ARDUINO)/wiring.c \
$(ARDUINO)/wiring_analog.c $(ARDUINO)/wiring_digital.c \
$(ARDUINO)/wiring_pulse.c \
$(ARDUINO)/wiring_shift.c $(ARDUINO)/WInterrupts.c
CXXSRC = $(ARDUINO)/HardwareSerial.cpp $(ARDUINO)/WMath.cpp \
$(ARDUINO)/Print.cpp
FORMAT = ihex


# Name of this Makefile (used for "make depend").
MAKEFILE = Makefile

# Debugging format.
# Native formats for AVR-GCC''-g are stabs [default], or dwarf-2.
# AVR (extended) COFF requires stabs, plus an avr-objcopy run.
DEBUG = stabs

OPT = s

# Place -D or -U options here
CDEFS = -DF_CPU=$(F_CPU)
CXXDEFS = -DF_CPU=$(F_CPU)

# Place -I options here
CINCS = -I$(ARDUINO)
CXXINCS = -I$(ARDUINO)

# Compiler flag to set the C Standard level.
# c89   - "ANSI" C
# gnu89 - c89 plus GCC extensions
# c99   - ISO C99 standard (not yet fully implemented)
# gnu99 - c99 plus GCC extensions
CSTANDARD = -std=gnu99
CDEBUG = -g$(DEBUG)
CWARN = -Wall -Wstrict-prototypes
CTUNING = -funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums
#CEXTRA = -Wa,-adhlns=$(<:.c=.lst)

CFLAGS = $(CDEBUG) $(CDEFS) $(CINCS) -O$(OPT) $(CWARN) $(CSTANDARD) $(CEXTRA)
CXXFLAGS = $(CDEFS) $(CINCS) -O$(OPT)
#ASFLAGS = -Wa,-adhlns=$(<:.S=.lst),-gstabs 
LDFLAGS = -lm


# Programming support using avrdude. Settings and variables.
AVRDUDE_PORT = $(PORT)
AVRDUDE_WRITE_FLASH = -U flash:w:applet/$(TARGET).hex
AVRDUDE_FLAGS = -V -F -C $(INSTALL_DIR)/hardware/tools/avr/etc/avrdude.conf \
-p $(MCU) -P $(AVRDUDE_PORT) -c $(AVRDUDE_PROGRAMMER) \
-b $(UPLOAD_RATE)

# Program settings
CC = $(AVR_TOOLS_PATH)/avr-gcc
CXX = $(AVR_TOOLS_PATH)/avr-g++
OBJCOPY = $(AVR_TOOLS_PATH)/avr-objcopy
OBJDUMP = $(AVR_TOOLS_PATH)/avr-objdump
AR  = $(AVR_TOOLS_PATH)/avr-ar
SIZE = $(AVR_TOOLS_PATH)/avr-size
NM = $(AVR_TOOLS_PATH)/avr-nm
AVRDUDE = $(AVR_TOOLS_PATH)/avrdude
REMOVE = rm -f
MV = mv -f

# Define all object files.
OBJ = $(SRC:.c=.o) $(CXXSRC:.cpp=.o) $(ASRC:.S=.o) 

# Define all listing files.
LST = $(ASRC:.S=.lst) $(CXXSRC:.cpp=.lst) $(SRC:.c=.lst)

# Combine all necessary flags and optional flags.
# Add target processor to flags.
ALL_CFLAGS = -mmcu=$(MCU) -I. $(CFLAGS)
ALL_CXXFLAGS = -mmcu=$(MCU) -I. $(CXXFLAGS)
ALL_ASFLAGS = -mmcu=$(MCU) -I. -x assembler-with-cpp $(ASFLAGS)


# Default target.
all: applet_files build sizeafter

build: elf hex 

applet_files: $(TARGET).pde
	# Here is the "preprocessing".
	# It creates a .cpp file based with the same name as the .pde file.
	# On top of the new .cpp file comes the WProgram.h header.
	# At the end there is a generic main() function attached.
	# Then the .cpp file will be compiled. Errors during compile will
	# refer to this new, automatically generated, file. 
	# Not the original .pde file you actually edit...
	test -d applet || mkdir applet
	echo ''#include "WProgram.h"''> applet/$(TARGET).cpp 
	cat $(TARGET).pde >> applet/$(TARGET).cpp
	cat $(ARDUINO)/main.cxx >> applet/$(TARGET).cpp

elf: applet/$(TARGET).elf
hex: applet/$(TARGET).hex
eep: applet/$(TARGET).eep
lss: applet/$(TARGET).lss 
sym: applet/$(TARGET).sym

# Program the device.  
upload: applet/$(TARGET).hex
	$(AVRDUDE) $(AVRDUDE_FLAGS) $(AVRDUDE_WRITE_FLASH)


	# Display size of file.
HEXSIZE = $(SIZE) --target=$(FORMAT) applet/$(TARGET).hex
ELFSIZE = $(SIZE)  applet/$(TARGET).elf
sizebefore:
	@if [ -f applet/$(TARGET).elf ]; then echo; echo $(MSG_SIZE_BEFORE); $(HEXSIZE); echo; fi

sizeafter:
	@if [ -f applet/$(TARGET).elf ]; then echo; echo $(MSG_SIZE_AFTER); $(HEXSIZE); echo; fi


# Convert ELF to COFF for use in debugging / simulating in AVR Studio or VMLAB.
COFFCONVERT=$(OBJCOPY) --debugging \
--change-section-address .data-0x800000 \
--change-section-address .bss-0x800000 \
--change-section-address .noinit-0x800000 \
--change-section-address .eeprom-0x810000 


coff: applet/$(TARGET).elf
	$(COFFCONVERT) -O coff-avr applet/$(TARGET).elf $(TARGET).cof


extcoff: $(TARGET).elf
	$(COFFCONVERT) -O coff-ext-avr applet/$(TARGET).elf $(TARGET).cof


.SUFFIXES: .elf .hex .eep .lss .sym

.elf.hex:
	$(OBJCOPY) -O $(FORMAT) -R .eeprom $< $@

.elf.eep:
	-$(OBJCOPY) -j .eeprom --set-section-flags=.eeprom="alloc,load" \
	--change-section-lma .eeprom=0 -O $(FORMAT) $< $@

# Create extended listing file from ELF output file.
.elf.lss:
	$(OBJDUMP) -h -S $< > $@

# Create a symbol table from ELF output file.
.elf.sym:
	$(NM) -n $< > $@

	# Link: create ELF output file from library.
applet/$(TARGET).elf: $(TARGET).pde applet/core.a 
	$(CC) $(ALL_CFLAGS) -o $@ applet/$(TARGET).cpp -L. applet/core.a $(LDFLAGS)

applet/core.a: $(OBJ)
	@for i in $(OBJ); do echo $(AR) rcs applet/core.a $$i; $(AR) rcs applet/core.a $$i; done



# Compile: create object files from C++ source files.
.cpp.o:
	$(CXX) -c $(ALL_CXXFLAGS) $< -o $@ 

# Compile: create object files from C source files.
.c.o:
	$(CC) -c $(ALL_CFLAGS) $< -o $@ 


# Compile: create assembler files from C source files.
.c.s:
	$(CC) -S $(ALL_CFLAGS) $< -o $@


# Assemble: create object files from assembler source files.
.S.o:
	$(CC) -c $(ALL_ASFLAGS) $< -o $@


# Automatic dependencies
%.d: %.c
	$(CC) -M $(ALL_CFLAGS) $< | sed "s;$(notdir $*).o:;$*.o $*.d:;" > $@

%.d: %.cpp
	$(CXX) -M $(ALL_CXXFLAGS) $< | sed "s;$(notdir $*).o:;$*.o $*.d:;" > $@


# Target: clean project.
clean:
	$(REMOVE) applet/$(TARGET).hex applet/$(TARGET).eep applet/$(TARGET).cof applet/$(TARGET).elf \
	applet/$(TARGET).map applet/$(TARGET).sym applet/$(TARGET).lss applet/core.a \
	$(OBJ) $(LST) $(SRC:.c=.s) $(SRC:.c=.d) $(CXXSRC:.cpp=.s) $(CXXSRC:.cpp=.d)

.PHONY:	all build elf hex eep lss sym program coff extcoff clean applet_files sizebefore sizeafter

-include $(SRC:.c=.d)
-include $(CXXSRC:.cpp=.d)

'! !

!ArduinoSketchCompiler class methodsFor: 'instance creation' stamp: 'Richo 5/14/2010 17:52'!
on: anArduinoSketch
^self basicNew setSketch: anArduinoSketch! !

!ArduinoSketchCompiler methodsFor: 'compiling' stamp: 'Richo 5/14/2010 17:58'!
compile
self createSketchDirectory; createMakefile; createSourceFile! !

!ArduinoSketchCompiler methodsFor: 'compiling' stamp: 'Richo 7/12/2010 13:34'!
createMakefile
	| file |
	[file := CrLfFileStream forceNewFileNamed: (self sketchesDirectory pathName , '\', sketch name ,'\Makefile' ).
	file nextPutAll: self class makefile]
	ensure: [file close].! !

!ArduinoSketchCompiler methodsFor: 'compiling' stamp: 'Richo 5/14/2010 17:55'!
createSketchDirectory
(self sketchesDirectory directoryExists: sketch name)
		ifFalse: [self sketchesDirectory createDirectory: sketch name].
	! !

!ArduinoSketchCompiler methodsFor: 'compiling' stamp: 'Richo 7/14/2010 14:41'!
createSourceFile
	| file |
	file := FileStream forceNewFileNamed: (self sketchesDirectory pathName , '\', sketch name ,'\', sketch name , '.pde' ).
	[ArduinoCTranslator new translateSketch: sketch into: file]
	ensure: [file close].! !

!ArduinoSketchCompiler methodsFor: 'private' stamp: 'Richo 5/14/2010 17:52'!
setSketch: anArduinoSketch
sketch := anArduinoSketch! !

!ArduinoSketchCompiler methodsFor: 'accessing' stamp: 'Richo 5/14/2010 17:58'!
sketchesDirectory
"It is important to keep this structure!!!!"
	^ (FileDirectory default directoryNamed: 'Arduino')
		directoryNamed: 'Sketches'! !

!ArduinoSketchCompiler methodsFor: 'uploading' stamp: 'Richo 5/14/2010 18:12'!
uploadOnPort: portName arduinoType: arduinoType 
	self compile.
	ArduinoSketchUploader new
		uploadSketchNamed: sketch name
		onPort: portName
		arduinoType: arduinoType ! !

Object subclass: #ArduinoSketchUploader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

!ArduinoSketchUploader commentStamp: 'Richo 3/9/2010 12:57' prior: 0!
I'm responsible for uploading sketches to the Arduino board. My protocol is very simple: #uploadSketchNamed:onPort:arduinoType:

To accomplish this task I need a specific directory tree:

.\Arduino
.\Arduino\hardware
.\Arduino\hardware\cores
.\Arduino\hardware\cores\arduino 
	"Contains the arduino source code (needed for compilation)"
.\Arduino\hardware\libraries
	"Contains all the needed libraries in separate folders"
.\Arduino\hardware\tools\
.\Arduino\hardware\tools\avr\
	"Contains the avr installation"
.\Arduino\Sketches
	"Contains the source code we are going to compile and upload"

Apart from that, I need a batch file called "upload.bat" in the sketches directory (.\Arduino\Sketches). This file is the responsible for calling make with the correct parameters, I simply execute it and hope for the best. 
Also, each sketch must have its own folder with a proper Makefile. The sketch folder must have the same name as the sketch. For instance, if I have a sketch named "Blink.pde" I must put it in ".\Arduino\Sketches\Blink". Otherwise, it won't compile.

!

!ArduinoSketchUploader methodsFor: 'compiling and uploading' stamp: 'Richo 3/30/2010 13:59'!
checkForErrorsOn: sketchDirectory
"I read a file named finished to see if the process ended correctly or there was an error"

	| file errorCode |
	file := FileStream fileNamed: (sketchDirectory fullPathFor: 'finished').
	errorCode := file contents.
	file close.
	errorCode asNumber = 1
		ifTrue: [^CompilingSketchError signal]! !

!ArduinoSketchUploader methodsFor: 'private' stamp: 'Richo 4/6/2011 10:58'!
executeInMacUploadFor: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId 
	"Do not call this, use
	#uploadSketch:onPort:arduinoType: "
	| osProcess |
	Transcript show: './upload.sh ' , sketchName , ' ' , portName , ' ' , uploadRate asString , ' ' , mcu , ' ' , fCpu asString , ' ' , programmerId;
		 cr.
	osProcess := Smalltalk at: #OSProcess ifAbsent: [^ self error: 'OSProcess not installed' translated].
	osProcess thisOSProcess chDir: (osProcess thisOSProcess environment at: 'APP')
			, '/Arduino/Sketches';
		 command: './upload.sh ' , sketchName , ' ' , portName , ' ' , uploadRate asString , ' ' , mcu , ' ' , fCpu asString , ' ' , programmerId! !

!ArduinoSketchUploader methodsFor: 'private' stamp: 'Richo 4/6/2011 10:57'!
executeInUnixUploadFor: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId 
	"Do not call this, use
	#uploadSketch:onPort:arduinoType: "
	(Smalltalk
		at: #OSProcess
		ifAbsent: [^ self error: 'OSProcess not installed' translated]) thisOSProcess chDir: (SmalltalkImage current imagePath , '/Arduino/Sketches');
		 command: './upload.sh ' , sketchName , ' ' , portName , ' ' , uploadRate asString , ' ' , mcu , ' ' , fCpu asString , ' ' , programmerId! !

!ArduinoSketchUploader methodsFor: 'private' stamp: 'Richo 4/6/2011 10:57'!
executeInWin32UploadFor: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId 
	"Do not call this, use #uploadSketch:onPort:arduinoType:"
	((Smalltalk
			at: #Win32Shell
			ifAbsent: [^ self error: 'FFI not installed' translated]) new
			shellExecute: nil
			lpOperation: 'open'
			lpFile: 'upload.bat'
			lpParameters: sketchName , ' ' , portName , ' ' , uploadRate asString , ' ' , mcu , ' ' , fCpu asString , ' ' , programmerId
			lpDirectory: 'Arduino/Sketches'
			nShowCmd: 1)
			<= 32
		ifTrue: [self error: 'System error' translated]! !

!ArduinoSketchUploader methodsFor: 'private' stamp: 'Richo 4/6/2011 10:58'!
executeUploadFor: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId 
	"Do not call this, use #uploadSketch:onPort:arduinoType:"
	SmalltalkImage current platformName = 'unix'
		ifTrue: [^ self
				executeInUnixUploadFor: sketchName
				onPort: portName
				uploadRate: uploadRate
				mcu: mcu
				fCpu: fCpu
				avrdudeProgrammer: programmerId].
	SmalltalkImage current platformName = 'Mac OS'
		ifTrue: [^ self
				executeInMacUploadFor: sketchName
				onPort: portName
				uploadRate: uploadRate
				mcu: mcu
				fCpu: fCpu
				avrdudeProgrammer: programmerId].
	SmalltalkImage current platformName =  'Win32'
		ifTrue: [^ self
				executeInWin32UploadFor: sketchName
				onPort: portName
				uploadRate: uploadRate
				mcu: mcu
				fCpu: fCpu
				avrdudeProgrammer: programmerId].
	^self error: SmalltalkImage current platformName, ' - Platform not supported' translated! !

!ArduinoSketchUploader methodsFor: 'testing' stamp: 'Richo 1/4/2010 17:14'!
hasMakefile: sketchDirectory 
	^ sketchDirectory
		fileExists: 'Makefile'! !

!ArduinoSketchUploader methodsFor: 'accessing' stamp: 'Richo 1/4/2010 17:13'!
sketchesDirectory
"It is important to keep this structure!!!!"
	^ (FileDirectory default directoryNamed: 'Arduino')
		directoryNamed: 'Sketches'! !

!ArduinoSketchUploader methodsFor: 'accessing' stamp: 'Richo 1/5/2010 12:45'!
timeoutSeconds
^45! !

!ArduinoSketchUploader methodsFor: 'compiling and uploading' stamp: 'Richo 1/31/2011 10:34'!
uploadFirmataOnPort: portName arduinoType: arduinoType 
	self
		uploadSketchNamed: 'StandardFirmata'
		onPort: portName
		arduinoType: arduinoType! !

!ArduinoSketchUploader methodsFor: 'compiling and uploading' stamp: 'Richo 1/31/2011 09:55'!
uploadSketchNamed: sketchName onPort: portName arduinoType: arduinoType 
	"self new uploadSketchNamed: 'Blink'
	onPort: 'COM6'
	arduinoType: (ArduinoType at: #ArduinoATmega328)" 
	self
		uploadSketchNamed: sketchName
		onPort: portName
		uploadRate: arduinoType uploadRate
		mcu: arduinoType mcu
		fCpu: arduinoType fCpu
		avrdudeProgrammer: arduinoType avrdudeProgrammer! !

!ArduinoSketchUploader methodsFor: 'compiling and uploading' stamp: 'Richo 4/6/2011 10:58'!
uploadSketchNamed: sketchName onPort: portName uploadRate: uploadRate mcu: mcu fCpu: fCpu avrdudeProgrammer: programmerId 
	| sketchDirectory |
	sketchDirectory := self sketchesDirectory directoryNamed: sketchName.
	(self hasMakefile: sketchDirectory)
		ifFalse: [^ self error: 'No Makefile' translated].
	self
		waitFor: self timeoutSeconds
		untilFinish: [self
				executeUploadFor: sketchName
				onPort: portName
				uploadRate: uploadRate
				mcu: mcu
				fCpu: fCpu
				avrdudeProgrammer: programmerId]
		on: sketchDirectory! !

!ArduinoSketchUploader methodsFor: 'compiling and uploading' stamp: 'Richo 1/13/2010 17:25'!
waitFor: timeoutSeconds untilFinish: uploadBlock on: sketchDirectory 
	"Para asegurarme que el proceso haya terminado correctamente, espero
	hasta que en el directory del sketch exista un archivo llamado
	'finished' o se supere un determinado timeout"
	| delay timeout |
	timeout := timeoutSeconds.
	sketchDirectory
		deleteFileNamed: 'finished'
		ifAbsent: [].
	uploadBlock value.
	delay := Delay forSeconds: 1.
	[delay wait.
	timeout := timeout - 1]
		doWhileFalse: [timeout = 0
				or: [sketchDirectory fileExists: 'finished']].
	timeout = 0
		ifTrue: [^UploadingSketchError signal].
	self checkForErrorsOn: sketchDirectory! !

Object subclass: #ArduinoTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Translator'!

!ArduinoTranslator methodsFor: 'translating' stamp: 'Richo 7/28/2010 15:32'!
translateSketch: sketch 
	^ ArduinoProgramNode
		vars: (sketch instVarNames
				collect: [:each | ArduinoVariableNode name: each])
		functions: (sketch selectors
				collect: [:selector | (Parser new
						parse: (sketch sourceCodeAt: selector)
						class: sketch)
						translateWith: self]) ! !

Object subclass: #InstVarInfo
	instanceVariableNames: 'name type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Translator'!

!InstVarInfo class methodsFor: 'instance creation' stamp: 'Richo 7/14/2010 14:46'!
name: nameString type: typeString
^(self basicNew setName: nameString type: typeString) initialize! !

!InstVarInfo methodsFor: 'accessing' stamp: 'Richo 7/14/2010 14:52'!
name
^name! !

!InstVarInfo methodsFor: 'private' stamp: 'Richo 7/14/2010 14:47'!
setName: nameString type: typeString
	name := nameString.
	type := typeString
! !

!InstVarInfo methodsFor: 'accessing' stamp: 'Richo 7/14/2010 14:53'!
type
^type! !

Object subclass: #MethodInfo
	instanceVariableNames: 'returnType argTypes selector tempTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Translator'!

!MethodInfo class methodsFor: 'instance creation' stamp: 'Richo 7/14/2010 17:15'!
selector: selector returnType: returnType argTypes: argTypes tempTypes: tempTypes
^(self basicNew setSelector: selector returnType: returnType argTypes: argTypes tempTypes: tempTypes) initialize! !

!MethodInfo methodsFor: 'accessing' stamp: 'Richo 7/14/2010 15:58'!
argTypes
^argTypes ! !

!MethodInfo methodsFor: 'accessing' stamp: 'Richo 7/14/2010 15:42'!
returnType
^returnType! !

!MethodInfo methodsFor: 'accessing' stamp: 'Richo 7/14/2010 15:41'!
selector
^selector! !

!MethodInfo methodsFor: 'private' stamp: 'Richo 7/14/2010 17:15'!
setSelector: selectorSymbol returnType: returnTypeString argTypes: argTypesArray tempTypes: tempTypesArray
	selector := selectorSymbol.
	returnType := returnTypeString.
	argTypes := argTypesArray.
	tempTypes := tempTypesArray ! !

!MethodInfo methodsFor: 'accessing' stamp: 'Richo 7/14/2010 17:15'!
tempTypes
^tempTypes ! !

!CascadeNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/3/2010 17:17'!
translateInto: aStream with: aTranslator
	aTranslator translateCascadeNode: self into: aStream! !

Error subclass: #CompilingSketchError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

Error subclass: #UploadingSketchError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Uploading'!

!UploadingSketchError commentStamp: 'Richo 1/11/2010 15:24' prior: 0!
I'm just an Error class indicating that a sketch was not successfully uploaded to the arduino board!

!ParseNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 14:55'!
translateInto: aStream with: aTranslator 
	self subclassResponsibility! !

!AssignmentNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 18:05'!
translateInto: aStream with: aTranslator
	aTranslator translateAssignmentNode: self into: aStream! !

!MessageNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 15:08'!
translateInto: aStream with: aTranslator 
aTranslator translateMessageNode: self into: aStream! !

!LeafNode methodsFor: '*Arduino-Compiler-translating' stamp: 'Richo 3/2/2010 15:23'!
translateInto: aStream with: aTranslator 
aTranslator translateLeafNode: self into: aStream! !

TestCase subclass: #ArduinoParseNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Tests'!

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/4/2010 14:04'!
testAssignmentNodeEquality
	self assert: (ArduinoAssignmentNode variable: (ArduinoVariableNode name: 'abc') value: (ArduinoLiteralNode key: 6))
			= (ArduinoAssignmentNode variable: (ArduinoVariableNode name: 'abc') value: (ArduinoLiteralNode key: 6)).
	self deny: (ArduinoAssignmentNode variable: (ArduinoVariableNode name: 'abc') value: (ArduinoLiteralNode key: 6))
			= (ArduinoAssignmentNode variable: (ArduinoVariableNode name: 'abc') value: (ArduinoLiteralNode key: 7)).
	self deny: (ArduinoAssignmentNode variable: (ArduinoVariableNode name: 'abcd') value: (ArduinoLiteralNode key: 6))
			= (ArduinoAssignmentNode variable: (ArduinoVariableNode name: 'abc') value: (ArduinoLiteralNode key: 6))! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/20/2010 17:11'!
testBlockNodeEquality
	self assert: (ArduinoPreTranslator new translateExpression: '[ | a b | ^a > b ifTrue: [a] ifFalse: [b]]')
			= (ArduinoPreTranslator new translateExpression: '[ | a b | ^a > b ifTrue: [a] ifFalse: [b]]').
	self deny: (ArduinoPreTranslator new translateExpression: '[ | a b | ^a < b ifTrue: [a] ifFalse: [b]]')
			= (ArduinoPreTranslator new translateExpression: '[ | a b | ^a > b ifTrue: [a] ifFalse: [b]]')! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/20/2010 16:08'!
testFunctionCallNodeEquality
	self assert: (ArduinoFunctionCallNode
			name: (ArduinoFunctionNameNode key: 'pepe')
			parameters: #())
			= (ArduinoFunctionCallNode
					name: (ArduinoFunctionNameNode key: 'pepe')
					parameters: #()).
	self assert: (ArduinoFunctionCallNode
			name: (ArduinoFunctionNameNode key: 'pepe:and:')
			parameters: {ArduinoLiteralNode key: 9. ArduinoFunctionCallNode
					name: (ArduinoFunctionNameNode key: 'pepe')
					parameters: #()})
			= (ArduinoFunctionCallNode
					name: (ArduinoFunctionNameNode key: 'pepe:and:')
					parameters: {ArduinoLiteralNode key: 9. ArduinoFunctionCallNode
							name: (ArduinoFunctionNameNode key: 'pepe')
							parameters: #()}).
	self deny: (ArduinoFunctionCallNode
			name: (ArduinoFunctionNameNode key: 'pepe:and:')
			parameters: {ArduinoLiteralNode key: 19. ArduinoFunctionCallNode
					name: (ArduinoFunctionNameNode key: 'pepe')
					parameters: #()})
			= (ArduinoFunctionCallNode
					name: (ArduinoFunctionNameNode key: 'pepe:and:')
					parameters: {ArduinoLiteralNode key: 9. ArduinoFunctionCallNode
							name: (ArduinoFunctionNameNode key: 'pepe')
							parameters: #()}).
	self deny: (ArduinoFunctionCallNode
			name: (ArduinoFunctionNameNode key: 'pepe:')
			parameters: {ArduinoLiteralNode key: 9. ArduinoFunctionCallNode
					name: (ArduinoFunctionNameNode key: 'pepe')
					parameters: #()})
			= (ArduinoFunctionCallNode
					name: (ArduinoFunctionNameNode key: 'pepe:and:')
					parameters: {ArduinoLiteralNode key: 9. ArduinoFunctionCallNode
							name: (ArduinoFunctionNameNode key: 'pepe')
							parameters: #()})! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/20/2010 15:34'!
testFunctionNameNodeEquality
	self assert: (ArduinoFunctionNameNode key: 'abc')
			= (ArduinoFunctionNameNode key: 'abc').
	self deny: (ArduinoFunctionNameNode key: 'pepe')
			= (ArduinoFunctionNameNode key: 'abc').! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/20/2010 16:53'!
testFunctionNodeEquality
	self
		assert: (ArduinoFunctionNode
				name: (ArduinoFunctionNameNode key: 'pepe')
				parameters: #()
				temporaries: #()
				body: (ArduinoBlockNode vars: #() statements: {ArduinoOperatorNode
							operator: (ArduinoOperatorSymbolNode key: #*)
							parameters: {ArduinoVariableNode name: 'a'. ArduinoLiteralNode key: 6}})) = (ArduinoFunctionNode
				name: (ArduinoFunctionNameNode key: 'pepe')
				parameters: #()
				temporaries: #()
				body: (ArduinoBlockNode vars: #() statements: {ArduinoOperatorNode
							operator: (ArduinoOperatorSymbolNode key: #*)
							parameters: {ArduinoVariableNode name: 'a'. ArduinoLiteralNode key: 6}}))! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/4/2010 14:15'!
testLiteralNodeEquality
	self assert: (ArduinoLiteralNode key: 'abc')
			= (ArduinoLiteralNode key: 'abc').
	self deny: (ArduinoLiteralNode key: 'pepe')
			= (ArduinoLiteralNode key: 'abc').
	self assert: (ArduinoLiteralNode key: 5)
			= (ArduinoLiteralNode key: 5).
	self deny: (ArduinoLiteralNode key: 'pepe')
			= (ArduinoLiteralNode key: 2)! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/20/2010 16:10'!
testLiteralVariableNodeEquality
	self assert: (ArduinoLiteralVariableNode name: 'abc' value: 1)
			= (ArduinoLiteralVariableNode name: 'abc' value: 1).
	self deny: (ArduinoLiteralVariableNode name: 'pepe' value: 1)
			= (ArduinoLiteralVariableNode name: 'abc' value: 1).
	self deny: (ArduinoLiteralVariableNode name: 'pepe' value: 1)
			= (ArduinoLiteralVariableNode name: 'pepe' value: 0)! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/20/2010 15:41'!
testOperatorNodeEquality
	self assert: (ArduinoOperatorNode
			operator: (ArduinoOperatorSymbolNode key: #+)
			parameters: {ArduinoLiteralNode key: 3. ArduinoLiteralNode key: 4})
			= (ArduinoOperatorNode
					operator: (ArduinoOperatorSymbolNode key: #+)
					parameters: {ArduinoLiteralNode key: 3. ArduinoLiteralNode key: 4}).
	self deny: (ArduinoOperatorNode
			operator: (ArduinoOperatorSymbolNode key: #+)
			parameters: {ArduinoLiteralNode key: 3. ArduinoLiteralNode key: 4})
			= (ArduinoOperatorNode
					operator: (ArduinoOperatorSymbolNode key: #+)
					parameters: {ArduinoLiteralNode key: 3. ArduinoLiteralNode key: 5}).
	self deny: (ArduinoOperatorNode
			operator: (ArduinoOperatorSymbolNode key: #*)
			parameters: {ArduinoLiteralNode key: 3. ArduinoLiteralNode key: 4})
			= (ArduinoOperatorNode
					operator: (ArduinoOperatorSymbolNode key: #+)
					parameters: {ArduinoLiteralNode key: 3. ArduinoLiteralNode key: 3})! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/20/2010 15:36'!
testOperatorSymbolNodeEquality
	self assert: (ArduinoOperatorSymbolNode key: #+)
			= (ArduinoOperatorSymbolNode key: #+).
	self deny: (ArduinoOperatorSymbolNode key: #-)
			= (ArduinoOperatorSymbolNode key: #+)! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/20/2010 17:00'!
testReturnNodeEquality
	self assert: (ArduinoPreTranslator new translateExpression: '^ 1000 factorial')
			= (ArduinoPreTranslator new translateExpression: '^ 1000 factorial').
	self deny: (ArduinoPreTranslator new translateExpression: '^ 1000 factorial')
			= (ArduinoPreTranslator new translateExpression: '^ 10000000 factorial')! !

!ArduinoParseNodeTest methodsFor: 'as yet unclassified' stamp: 'Richo 8/4/2010 14:14'!
testVariableNodeEquality
	self assert: (ArduinoVariableNode name: 'abc')
			= (ArduinoVariableNode name: 'abc').
	self deny: (ArduinoVariableNode name: 'pepe')
			= (ArduinoVariableNode name: 'abc').
! !

TestCase subclass: #ArduinoPreTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-Compiler-Tests'!

!ArduinoPreTranslatorTest methodsFor: 'accessing' stamp: 'Richo 8/23/2010 18:42'!
returnSelf
	^ArduinoReturnNode expression: (ArduinoVariableNode name: 'self')! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 12:43'!
testEmptyMethod
	self assert: (ArduinoPreTranslator new translateMethod: 'emptyMethod')
			= (self
					unaryFunctionNamed: #emptyMethod
					withBody: (ArduinoBlockNode vars: #() statements: {self returnSelf}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/20/2010 18:27'!
testIfFalse
	self assert: (ArduinoPreTranslator new translateExpression: '((true)) ifFalse: [1]')
			= (ArduinoConditionalNode
					condition: (ArduinoVariableNode name: 'true')
					trueBranch: (ArduinoBlockNode vars: #() statements: {ArduinoVariableNode name: 'nil'})
					falseBranch: (ArduinoBlockNode vars: #() statements: {ArduinoLiteralNode key: 1}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/23/2010 18:50'!
testIfFalseIfTrue
	self assert: (ArduinoPreTranslator new translateExpression: 'true ifFalse: [1] ifTrue: [0]')
			= (ArduinoConditionalNode
					condition: (ArduinoVariableNode name: 'true')
					trueBranch: (ArduinoBlockNode vars: #() statements: {ArduinoLiteralNode key: 0})
					falseBranch: (ArduinoBlockNode vars: #() statements: {ArduinoLiteralNode key: 1})) ! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/20/2010 18:22'!
testIfTrue
	self assert: (ArduinoPreTranslator new translateExpression: 'true ifTrue: [1]')
			= (ArduinoConditionalNode
					condition: (ArduinoVariableNode name: 'true')
					trueBranch: (ArduinoBlockNode vars: #() statements: {ArduinoLiteralNode key: 1})
					falseBranch: (ArduinoBlockNode vars: #() statements: {ArduinoVariableNode name: 'nil'}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/23/2010 18:44'!
testIfTrueIfFalse
	self assert: (ArduinoPreTranslator new translateExpression: 'true ifTrue: [1] ifFalse: [0]')
			= (ArduinoConditionalNode
					condition: (ArduinoVariableNode name: 'true')
					trueBranch: (ArduinoBlockNode vars: #() statements: {ArduinoLiteralNode key: 1})
					falseBranch: (ArduinoBlockNode vars: #() statements: {ArduinoLiteralNode key: 0})) ! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 12:42'!
testMethodReturningUnaryMessageSend
	self assert: (ArduinoPreTranslator new translateMethod: 'methodWithUnaryMessage ^self message')
			= (self
					unaryFunctionNamed: #methodWithUnaryMessage
					withBody: (ArduinoBlockNode vars: #() statements: {ArduinoReturnNode
								expression: (ArduinoFunctionCallNode
										name: (ArduinoFunctionNameNode key: #message)
										parameters: #())}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 13:38'!
testMethodSendingBinaryMessage
	self assert: (ArduinoPreTranslator new translateMethod: 'method ^ 3 + 4')
			= (self
					unaryFunctionNamed: #method
					withBody: (ArduinoBlockNode vars: #() statements: {ArduinoReturnNode
								expression: (ArduinoOperatorNode
										operator: (ArduinoOperatorSymbolNode key: #+)
										parameters: {ArduinoLiteralNode key: 3. ArduinoLiteralNode key: 4})}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 12:58'!
testMethodSendingKeywordMessageWithANilVariableArgument
	self assert: (ArduinoPreTranslator new translateMethod: 'method self message: var')
			= (self
					unaryFunctionNamed: #method
					withBody: (ArduinoBlockNode vars: #() statements: {ArduinoFunctionCallNode
								name: (ArduinoFunctionNameNode key: #message:)
								parameters: {ArduinoLiteralVariableNode name: 'var' value: nil}. self returnSelf}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 12:48'!
testMethodSendingKeywordMessageWithOneStringArgument
	self assert: (ArduinoPreTranslator new translateMethod: 'method self message: ''richo''')
			= (self
					unaryFunctionNamed: #method
					withBody: (ArduinoBlockNode vars: #() statements: {ArduinoFunctionCallNode
								name: (ArduinoFunctionNameNode key: #message:)
								parameters: {ArduinoLiteralNode key: 'richo'}. self returnSelf})).! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 12:48'!
testMethodSendingKeywordMessageWithTwoNumberArguments
	self assert: (ArduinoPreTranslator new translateMethod: 'method self message: 2 and: 3')
			= (self
					unaryFunctionNamed: #method
					withBody: (ArduinoBlockNode vars: #() statements: {ArduinoFunctionCallNode
								name: (ArduinoFunctionNameNode key: #message:and:)
								parameters: {ArduinoLiteralNode key: 2. ArduinoLiteralNode key: 3}. self returnSelf})).! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 12:44'!
testMethodSendingUnaryMessage
	self assert: (ArduinoPreTranslator new translateMethod: 'methodWithUnaryMessage self message')
			= (self
					unaryFunctionNamed: #methodWithUnaryMessage
					withBody: (ArduinoBlockNode vars: #() statements: {ArduinoFunctionCallNode
								name: (ArduinoFunctionNameNode key: #message)
								parameters: #(). self returnSelf}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/23/2010 18:45'!
testMethodWithCascadeMessage
	self assert: (ArduinoPreTranslator new translateMethod: 'emptyMethod self a; b; c')
			= (self
					unaryFunctionNamed: 'emptyMethod'
					withBody: (ArduinoBlockNode vars: #() statements: {ArduinoFunctionCallNode
								name: (ArduinoFunctionNameNode key: 'a')
								parameters: #(). ArduinoFunctionCallNode
								name: (ArduinoFunctionNameNode key: 'b')
								parameters: #(). ArduinoFunctionCallNode
								name: (ArduinoFunctionNameNode key: 'c')
								parameters: #(). self returnSelf})) ! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 13:31'!
testMethodWithTempVarAssignmentOfLiteralNumber
	| arduinoTree |
	arduinoTree := ArduinoPreTranslator new translateMethod: 'method | temp | temp := 5'.
	self deny: arduinoTree
			= (ArduinoFunctionNode
					name: (ArduinoFunctionNameNode key: #method)
					parameters: #()
					temporaries: #()
					body: (ArduinoBlockNode vars: #() statements: {ArduinoAssignmentNode
								variable: (ArduinoVariableNode name: 'temp')
								value: (ArduinoLiteralNode key: 5). self returnSelf})).
	self assert: arduinoTree
			= (ArduinoFunctionNode
					name: (ArduinoFunctionNameNode key: #method)
					parameters: #()
					temporaries: {ArduinoVariableNode name: 'temp'}
					body: (ArduinoBlockNode vars: #() statements: {ArduinoAssignmentNode
								variable: (ArduinoVariableNode name: 'temp')
								value: (ArduinoLiteralNode key: 5). self returnSelf}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/4/2010 13:34'!
testMethodWithTempVarAssignmentOfMessageSend
	| arduinoTree |
	arduinoTree := ArduinoPreTranslator new translateMethod: 'method | temp | temp := self millis'.
	self assert: arduinoTree
			= (ArduinoFunctionNode
					name: (ArduinoFunctionNameNode key: #method)
					parameters: #()
					temporaries: {ArduinoVariableNode name: 'temp'}
					body: (ArduinoBlockNode vars: #() statements: {ArduinoAssignmentNode
								variable: (ArduinoVariableNode name: 'temp')
								value: (ArduinoFunctionCallNode name: (ArduinoFunctionNameNode key: #millis) parameters: #()). self returnSelf}))! !

!ArduinoPreTranslatorTest methodsFor: 'tests-utilities' stamp: 'Richo 8/3/2010 17:35'!
testMustBeAbleToFlattenCollections
	"Some methods, like #visitCascadeNode: return a collection of nodes.
	This collection must be flatten in the sender code before using it"
	self assert: (ArduinoPreTranslator new flatten: #(1 2 3 'Richo' #(4 5 6 'Capo' #(3 ) ) #() ))
			= #(1 2 3 'Richo' 4 5 6 'Capo' 3 )! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/23/2010 17:23'!
testToByDo
	self assert: (ArduinoPreTranslator new translateExpression: '1 to: 10 do: [:i | i]')
			= (ArduinoLoopNode
					initializer: (ArduinoAssignmentNode
							variable: (ArduinoVariableNode name: 'i')
							value: (ArduinoLiteralNode key: 1))
					test: (ArduinoOperatorNode
							operator: (ArduinoOperatorSymbolNode key: #'<=')
							parameters: {ArduinoVariableNode name: 'i'. ArduinoLiteralNode key: 10})
					body: (ArduinoBlockNode vars: #() statements: {ArduinoVariableNode name: 'i'})
					counting: (ArduinoAssignmentNode
							variable: (ArduinoVariableNode name: 'i')
							value: (ArduinoOperatorNode
									operator: (ArduinoOperatorSymbolNode key: #+)
									parameters: {ArduinoVariableNode name: 'i'. ArduinoLiteralNode key: 1}))).
	self assert: (ArduinoPreTranslator new translateExpression: '1 to: 100 by: 2 do: [:i | i]')
			= (ArduinoLoopNode
					initializer: (ArduinoAssignmentNode
							variable: (ArduinoVariableNode name: 'i')
							value: (ArduinoLiteralNode key: 1))
					test: (ArduinoOperatorNode
							operator: (ArduinoOperatorSymbolNode key: #'<=')
							parameters: {ArduinoVariableNode name: 'i'. ArduinoLiteralNode key: 100})
					body: (ArduinoBlockNode vars: #() statements: {ArduinoVariableNode name: 'i'})
					counting: (ArduinoAssignmentNode
							variable: (ArduinoVariableNode name: 'i')
							value: (ArduinoOperatorNode
									operator: (ArduinoOperatorSymbolNode key: #+)
									parameters: {ArduinoVariableNode name: 'i'. ArduinoLiteralNode key: 2}))).
! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/23/2010 18:04'!
testWhileFalse
	self assert: (ArduinoPreTranslator new translateExpression: '[true] whileFalse: [1000]')
			= (ArduinoLoopNode
					initializer: ArduinoNoOpNode new
					test: (ArduinoBlockNode vars: #() statements: {ArduinoFunctionCallNode
							name: (ArduinoFunctionNameNode key: 'not')
							parameters: {ArduinoVariableNode name: 'true'}})
					body: (ArduinoBlockNode vars: #() statements: {ArduinoLiteralNode key: 1000})
					counting: ArduinoNoOpNode new)! !

!ArduinoPreTranslatorTest methodsFor: 'tests-translating' stamp: 'Richo 8/23/2010 17:27'!
testWhileTrue
	self assert: (ArduinoPreTranslator new translateExpression: '[true] whileTrue: [1000]')
			= (ArduinoLoopNode
					initializer: ArduinoNoOpNode new
					test: (ArduinoBlockNode vars: #() statements: {ArduinoVariableNode name: 'true'})
					body: (ArduinoBlockNode vars: #() statements: {ArduinoLiteralNode key: 1000})
					counting: ArduinoNoOpNode new).! !

!ArduinoPreTranslatorTest methodsFor: 'accessing' stamp: 'Richo 8/4/2010 13:19'!
unaryFunctionNamed: name withBody: body
"Convenient way of creating a function node representing a unary message"
	^ ArduinoFunctionNode
		name: (ArduinoFunctionNameNode key: name)
		parameters: #()
		temporaries: #()
		body: body! !
ArduinoSketch initialize!
